<!DOCTYPE html>
<html lang="es">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Capitulo_2</title>
</head>
<body>
    <h1>Capitulo 2</h1>
    <a>Ejercicio 7</a>

    <script>

//Incompleto


class Node {
    constructor(elemento) {
        this.data = elemento;
        this.next = null;
    }
}

let head1, head2;

function getNode() {
    let c1 = getCount(head1),
        c2 = getCount(head2),
        d;

    if (c1 > c2) {
        d = c1 - c2;
        return _getIntersectionNode( d, head1, head2 );
    } else {
        d = c2 - c1;
        return _getIntersectionNode( d, head2, head1 );
    }
}


function _getIntersectionNode(d,node1,node2) {
    let current1 = node1,
        current2 = node2;
    for (var i = 0; i < d; i++) {
        if (current1 == null) {
            return -1;
        }
        current1 = current1.next;
    }

    while (current1 != null && current2 != null) {
        if (current1.data == current2.data) {
            return current1.data;
        }
        current1 = current1.next;
        current2 = current2.next;
    }
    return -1;
}

function getCount(node) {
    let current = node,
        count   = 0;

    while (current != null) {
        count++;
        current = current.next;
    }

    return count;
}



head1 = new Node(3);
head1.next = new Node(6);
head1.next.next = new Node(9);
head1.next.next.next = new Node(15);
head1.next.next.next,next = new Node(30);

head2 = new Node(8);
head2.next = new Node(1);
head2.next.next = new Node(10);
head2.next.next.next = new Node(15);
head2.next.next.next,next = new Node(30);;

console.log(`El elemento que intersecta en las dos listas es:  ${getNode()}`);



    </script>
    
</body>
</html>